-- ===============================================
-- Author	  : FID.Intan	  
-- Create date: 12-Desember-2014
-- Description:	Insert Data to TB_T_DLV_FI_TRANS_D
-- Bug ID	  : 493
-- ===============================================

CREATE PROCEDURE [dbo].[SP_PROTO_INSERT_TEMP_TRANS_D_GR]
	@PROCESS_ID BIGINT,
	@DELIVERY_NOTE_NO VARCHAR(50),
	@DOC_NO VARCHAR(15)
AS

DECLARE
	@DOC_YEAR VARCHAR(4),
	@TRANSACTION_CD VARCHAR(3),
	@CONDITION_TYPE VARCHAR(5),
	@GL_ACCOUNT VARCHAR(10),
	@ITEM_TEXT VARCHAR(50),
	@EXCHANGE_RATE DECIMAL,
	@LOCAL_CURR_CD VARCHAR(3),
	@DC_INDICATOR VARCHAR(1),
	@LOCAL_CURR VARCHAR(3),
	@DOC_TYPE VARCHAR(2),
	@USERID VARCHAR(20),
	@CREATED_DT VARCHAR(20)
BEGIN
	--Get DOC Year
	SET @DOC_YEAR = CONVERT(VARCHAR, YEAR(GETDATE()))

	--Get Transaction Code
	SELECT @TRANSACTION_CD = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_TRANS_TYPE_GR_POST'

	--Get Item Text
	SELECT @ITEM_TEXT = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_ITEM_TXT'

	--Get Exchange Rate
	SELECT @EXCHANGE_RATE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_EXCHANGE_RATE'

	--Get Local Curr Cd
	SELECT @LOCAL_CURR_CD = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_LOCAL_CURR_CD'

	--Get Local Curr
	SELECT @LOCAL_CURR = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_LOCAL_CURR'
	
	--Get DOC Type
	SELECT @DOC_TYPE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_DOC_TYPE_GR'

	/*** Kredit ***/
	--Get Condition Type
	SELECT @CONDITION_TYPE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_CONDITION_TYPE_CREDIT'
	
	--Get Debit Credit Indicator
	SELECT @DC_INDICATOR = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_INDICATOR_CREDIT'

	--Get GL Account
	SELECT @GL_ACCOUNT = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_GL_ACC_GR_POST_CREDIT'

	SELECT TOP 1 @USERID = CONVERT(VARCHAR(20), UPDATE_BY) FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO
	SELECT TOP 1 @CREATED_DT = MAX(UPDATE_DT) FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO
	
	INSERT INTO TB_T_DLV_FI_TRANS_D 
	SELECT DISTINCT @DOC_NO AS DOC_NO,
		   @DOC_YEAR AS DOC_YEAR,
		   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_TRANS_D WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY DELIVERY_NOTE_NO) AS DOC_ITEM,
		   @CONDITION_TYPE AS CONDITION_TYPE,
		   @GL_ACCOUNT AS GL_ACCOUNT,
		   NULL AS ROUTE_CD,
		   [dbo].[fn_PROTO_GET_DOC_QTY](DELIVERY_NOTE_NO, @PROCESS_ID) * (-1) AS DOC_QTY,
		   [dbo].[fn_PROTO_GET_DOC_AMT](DELIVERY_NOTE_NO, @PROCESS_ID) * (-1) AS DOC_AMT,
		   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR_CD,
		   (CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT](DELIVERY_NOTE_NO, @PROCESS_ID)) * @EXCHANGE_RATE) AS LOCAL_AMT,
		   @LOCAL_CURR_CD AS LOCAL_CURR_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](DELIVERY_NOTE_NO, 'GR', '', '', @PROCESS_ID) AS PO_NO,
		   NULL AS TAX_CD,
		   @EXCHANGE_RATE AS EXCHANGE_RATE,
		   NULL AS COST_CENTER_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](DELIVERY_NOTE_NO, 'GR', '', '', @PROCESS_ID) AS ITEM_TEXT,
		   @TRANSACTION_CD AS TRANSACTION_NO,
		   CONVERT(VARCHAR(24), MAX(BUDGET_NO)) AS WBS_NO,
		   'PC' AS UOM,
		   @USERID AS CREATED_BY,
		   @CREATED_DT AS CREATED_DT,
		   NULL AS CHANGED_BY,
		   NULL AS CHANGED_DT
	FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO GROUP BY PROCESS_ID, DELIVERY_NOTE_NO, 
	CURR_CD ORDER BY PO_NO

	EXEC SP_PROTO_INSERT_DVL_FI_JOURNAL_GR @PROCESS_ID, @DOC_NO, @DOC_YEAR, @CONDITION_TYPE, @DC_INDICATOR, @GL_ACCOUNT, @LOCAL_CURR,
		@DOC_TYPE, @ITEM_TEXT, @EXCHANGE_RATE, @DELIVERY_NOTE_NO, '2', @TRANSACTION_CD

	/*** Debit ***/
	--Get Condition Type
	SELECT @CONDITION_TYPE = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_CONDITION_TYPE_DEBIT'

	--Get Debit Credit Indicator
	SELECT @DC_INDICATOR = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_INDICATOR_DEBIT'
	
	--Get GL Account
	SELECT @GL_ACCOUNT = SYSTEM_VALUE FROM TB_M_SYSTEM WHERE SYSTEM_CD = 'PROTO_GL_ACC_GR_POST_DEBIT'

	INSERT INTO TB_T_DLV_FI_TRANS_D 
	SELECT DISTINCT @DOC_NO AS DOC_NO,
		   @DOC_YEAR AS DOC_YEAR,
		   ISNULL((SELECT ISNULL(COUNT(DOC_NO),0) from TB_T_DLV_FI_TRANS_D WITH (HOLDLOCK, UPDLOCK) WHERE DOC_NO = @DOC_NO AND PROCESS_ID = @PROCESS_ID),0) 
					+ DENSE_RANK() OVER (ORDER BY DELIVERY_NOTE_NO),
		   @CONDITION_TYPE AS CONDITION_TYPE,
		   @GL_ACCOUNT AS GL_ACCOUNT,
		   NULL AS ROUTE_CD,
		   [dbo].[fn_PROTO_GET_DOC_QTY](DELIVERY_NOTE_NO, @PROCESS_ID) AS DOC_QTY,
		   [dbo].[fn_PROTO_GET_DOC_AMT](DELIVERY_NOTE_NO, @PROCESS_ID) AS DOC_AMT,
		   CONVERT(VARCHAR(3), CURR_CD) AS DOC_CURR_CD,
		   (CONVERT(NUMERIC(18, 0), [dbo].[fn_PROTO_GET_DOC_AMT](DELIVERY_NOTE_NO, @PROCESS_ID)) * @EXCHANGE_RATE) AS LOCAL_AMT,
		   @LOCAL_CURR_CD AS LOCAL_CURR_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](DELIVERY_NOTE_NO, 'GR', '', '', @PROCESS_ID) AS PO_NO,
		   NULL AS TAX_CD,
		   @EXCHANGE_RATE AS EXCHANGE_RATE,
		   NULL AS COST_CENTER_CD,
		   [dbo].[fn_PROTO_GET_PO_NO](DELIVERY_NOTE_NO, 'GR', '', '', @PROCESS_ID) AS ITEM_TEXT,
		   @TRANSACTION_CD AS TRANSACTION_NO,
		   CONVERT(VARCHAR(24), MAX(BUDGET_NO)) AS WBS_NO,
		   'PC' AS UOM,
		   @USERID AS CREATED_BY,
		   @CREATED_DT AS CREATED_DT,
		   NULL AS CHANGED_BY,
		   NULL AS CHANGED_DT
	FROM TB_T_PROTO_GR WHERE PROCESS_ID = @PROCESS_ID AND DELIVERY_NOTE_NO = @DELIVERY_NOTE_NO GROUP BY PROCESS_ID, DELIVERY_NOTE_NO, 
	CURR_CD ORDER BY PO_NO
	
	EXEC SP_PROTO_INSERT_DVL_FI_JOURNAL_GR @PROCESS_ID, @DOC_NO, @DOC_YEAR, @CONDITION_TYPE, @DC_INDICATOR, @GL_ACCOUNT, @LOCAL_CURR,
		@DOC_TYPE, @ITEM_TEXT, @EXCHANGE_RATE, @DELIVERY_NOTE_NO, '1', @TRANSACTION_CD
END

/****** Object:  StoredProcedure [dbo].[SP_PROTO_INSERT_DVL_FI_JOURNAL_GR]    Script Date: 3/25/2015 9:53:17 AM ******/

